/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




var threadURL = null;
var curReqNum = null;
var curForumPage = null;
var linkIndex = null;
var tmpDocLinks = null;
var useCacheIfAvail = null;
var cacheThang = null;
var unsep_list2 = null;

var doc_req = null;


////////////////////////////  The main function //////////////////////////

function leechThread() {
	suckMode = true;

	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	useCacheIfAvail = prefManager.getBoolPref("extensions.imagegrabber.cachethreadsuck");
	
	cacheThang = new Array();

	var continueOrNot = initVars();
	if (!continueOrNot) return;
	
	curReqNum = 0;
	curForumPage = firstPage;
	linkIndex = firstPage;
	tmpDocLinks = new Array();

	threadURL = content.document.URL;

	doc_req = setUp_suckerReq();

	doc_req = setUp_suckerLinkedList(doc_req);


	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) {
		ig_dl_win = ig_dl_win_obj.openWindow(null, "chrome://imagegrabber/content/interfaces/downloads.xul", "ig-dl_win", "resizable,scrollbars=yes", null);
		ig_dl_win.onload = finishUp2;
		}
	else {
		ig_dl_win.focus();
		finishUp2();
		}
}//end of function

function finishUp2() {
	updateDownloadStatus("Running....");

	for(var i = 0; i < doc_req.length; i++) {
		var m = doc_req[i].curLinkNum + 1;
		var page_stat = "Page " + doc_req[i].pageNum + ": " + m + " of " + doc_req[i].totLinkNum;
		addDownloadProgress(page_stat, doc_req[i].uniqID, doc_req[i].reqURL, "Waiting...");
		}


	if (doc_req.length == 0) return;
	doc_req[0].init();
	}



////////////////  The event function for xmlhttp //////////////////

function getRDun() {
	var req = this.parent;
	req.callwrapper.cancel();

	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
	if (toDieOrNot) return;

	var ref_url = req.reqURL;
	var pageData = this.responseText;

	var pageNum = req.pageNum;

	if (ref_url.match(/campusbug/)) pageNum++;
	
	updateDownloadStatus("Getting link information for Page " + pageNum);

	var tempLinks = getLinks(pageData);
	for (var i=0; i < tempLinks.length; i++) {
		try  {
			var someURI = ioService.newURI(tempLinks[i], null, null);
			}
		catch(e) {
			var someURI = ioService.newURI(ref_url, null, null);
			tempLinks[i] = someURI.resolve(tempLinks[i]);
			}
		}

	tmpDocLinks[pageNum] = tempLinks;

	req.finished = true;
	req.inprogress = false;

	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	var doc = ig_dl_win.document;
	var outBox = doc.getElementById("outBox");
	var treeItem = doc.getElementById(req.uniqID);
	outBox.removeChild(treeItem);

	req.queueHandler();
}



function setUp_suckerReq() {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
	if (toDieOrNot) return;

	

	if (!unsep_list2) {
		var forumStyleFileObj = new forumStyleFileService();
		var fsFile = forumStyleFileObj.getForumStyles();
		var forums = fsFile.getElementsByTagName("forum");
		unsep_list2 = "";

		for (i=0; i<forums.length; i++) {
			var uPatNode = forums[i].getElementsByTagName("urlpattern")[0];
			var uPat = "if (threadURL.match(/" + uPatNode.textContent + "/)) { ";
			var sPatNode = forums[i].getElementsByTagName("searchpattern")[0];
			var sPat = "retval = " + sPatNode.textContent + "; }";
			unsep_list2 += uPat + sPat + "\n\r";
			}
		}

	var temp_array = new Array()
	var count = 0;

	while (linkIndex <= lastPage) {
		var tmpURL = "";

		var retval = false;
		eval(unsep_list2);

		var tmpURL = retval(threadURL);

		if(tmpURL == "continue") continue;
		if(!tmpURL){
			updateDownloadStatus("Don't know how to handle this forum yet: " + threadURL + ".  Bailing!!!!!!!!");
			return;
			}


		var req = new requestObj();

		req.hostFunc = getRDun;
		req.queueHandler = sucker_queueHandler;
				
		req.reqURL = tmpURL;
		req.retryNum = maxRetries;
		req.pageNum = linkIndex;
		req.curLinkNum = 0;
		req.totLinkNum = 1;
		req.uniqID = "req_" + Math.round(Math.random() * 1e9);

		temp_array[count] = req;
		temp_array[req.uniqID] = temp_array[count];
		count++;
		linkIndex++;
		} // end of inner-for loop

	return temp_array;
	} // end of function






function setUp_suckerLinkedList(req_objs) {
	var lastObj = req_objs.length - 1;

	for(var i = 0; i < req_objs.length; i++) {
		if (i == 0) req_objs[i].previousRequest = null;
		else req_objs[i].previousRequest = req_objs[i-1];

		if (i == lastObj) req_objs[i].nextRequest = null;
		else req_objs[i].nextRequest = req_objs[i+1];

		req_objs[i].firstRequest = req_objs[0];
		req_objs[i].lastRequest = req_objs[lastObj];
		}

	return req_objs;
	}



function sucker_queueHandler() {
	var toDieOrNot = prefManager.getBoolPref("extensions.imagegrabber.killmenow");
	if (toDieOrNot) return;

	this.cp.curThread = this.countThreads();
	//this.cp.curThread--;

	var next_req = this.getNextAvailable(this.firstRequest);

	if (next_req) {
		next_req.init();
		}
	else {
		hostGrabber(tmpDocLinks);
		}
	}