/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/





function fuskem() {
	suckMode = false;
	// Initialize variables if not already initialized
	var feelItRex = initVars();
	if (!feelItRex) {
		return;
		}

	var docLinks = new Array();

	docLinks[firstPage] = new Array();

	var urlBox = document.getElementById("fuskemURL");

	var Weak = urlBox.value.match(/\[.+?\]/g)

	var searches = new Array();
	var cooches = new Array();

	for(var i = 0; i < Weak.length; i++) {
		searches[i] = Weak[i].match(/\[(.+)-(.+)\]/); 
		cooches[i] = doIt(searches[i][1], searches[i][2]); 
		}


	var position_lengths = new Array();
	var cur_position = new Array();

	var num_possibilities = 1;
	for(var i = 0; i < cooches.length; i++) {
		position_lengths[i] = cooches[i].length;
		num_possibilities *= cooches[i].length;
		cur_position[i] = 0;
		}

	return;

	var objLinks = setUpLinksOBJ(docLinks)

	if (req_objs != null) delete req_objs;
	req_objs = setUpReq(objLinks);

	req_objs = setUpLinkedList(req_objs);

	var ig_dl_win_obj = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	ig_dl_win = ig_dl_win_obj.getWindowByName("ig-dl_win", null);
	if (!ig_dl_win) {
		ig_dl_win = ig_dl_win_obj.openWindow(null, "chrome://imagegrabber/content/downloads.xul", "ig-dl_win", "resizable,scrollbars=yes", null);
		ig_dl_win.req_objs = req_objs;
		ig_dl_win.onload = finishUp;
		}
	else {
		delete ig_dl_win.req_objs;
		ig_dl_win.req_objs = req_objs;
		ig_dl_win.focus();
		finishUp();
		}

	}






/* startVal and endVal are strings */
function sanityCheck(startVal, endVal) {
	var useAlpha = 0;
	var useNum = 0;

	if (startVal.length > endVal.length) throw 1;

	for (var i = 0; i < startVal.length; i++) {
		var check1 = isNum(startVal[i]);
		if (check1) useNum++;

		var check2 = isAlpha(startVal[i]);
		if (check2 != -1) useAlpha++;

		if (useAlpha > 0 && useNum > 0) throw 1;
		}


	for (var j = 0; j < endVal.length; j++) {
		var check1 = isNum(endVal[j]);
		if (check1) useNum++;

		var check2 = isAlpha(endVal[j]);
		if (check2 != -1) useAlpha++;

		if (useAlpha > 0 && useNum > 0) throw 1;
		}		
	}




/* val is a single character */
function isNum(val) {
	var unicodeVal = val.charCodeAt(0);
	if(unicodeVal >= 48 && unicodeVal <= 57) return true;
	else return false;
	}



/* val is a single character */
function isAlpha(val) {
	var unicodeVal = val.charCodeAt(0);
	if(unicodeVal >= 65 && unicodeVal <= 90) return "upper";
	else if(unicodeVal >= 97 && unicodeVal <= 122) return "lower";
	else return -1;
	}



/* val is an array of numbers; base is an integer */
function decVal(val, base) {
	var pow = Math.pow;
	var decVal = 0;

	var j = 0;

	for(var i = val.length - 1; i >= 0; i--) decVal += val[j++]*pow(base, i);

	return decVal;
	}


/* Val and base are integers */
function toAlpha(Val, base) {

	var numArray = new Array();
	var count = 0;

	while (Val > 0) {
		var temp_b = Val/base;
		var temp_c = parseInt(temp_b);
		var temp_d = (temp_b - temp_c) * base + 1.5;
		
		numArray[count++] = parseInt(temp_d) - 1;
		Val = temp_c;
		}

	var thatsIt = new Array();

	var count = 0;
	var titty = numArray.length - 1;

	for(;titty >=0; titty--) {
		thatsIt[count++] = numArray[titty];
		}

	return thatsIt;
	}


/* val is a string of letters(case is ignored) */
function toNumbers(val) {
	var numArray = new Array();

	for(var i = 0; i < val.length; i++) {
		var temp_a = val.charCodeAt(i);
		if ( isAlpha(val[i]) == "upper" ) numArray[i] = temp_a - 65;
		else if ( isAlpha(val[i]) == "lower" ) numArray[i] = temp_a - 97;
		else if ( isNum(val[i]) ) numArray[i] = temp_a - 48;
		}
	return numArray;
	}




function doIt(startVal, endVal) {
	sanityCheck(startVal, endVal);

	var startNums = toNumbers(startVal);
	var endNums = toNumbers(endVal);

	if (isNum(startVal[0])) {
		var startIt = decVal( startNums, 10 );
		var endIt = decVal( endNums, 10 );
		}
	else {
		var startIt = decVal( startNums, 26 );
		var endIt = decVal( endNums, 26 );
		}

	var returnString = new Array();
	var count = 0;

	for (var i = startIt; i <= endIt; i++) {
		if(isAlpha(startVal[0]) != -1) var titty = toAlpha(i, 26);
		else var titty = toAlpha(i, 10);

		var newTitty = new Array();

		if(titty.length < startNums.length) {
			var tempCount = titty.length - 1;
			for (var j = startNums.length - 1; j >= 0; j--)
				newTitty[j] = tempCount >= 0?titty[tempCount--]:startNums[j];
			}
		else newTitty = titty;

		var outString = "";
		for (var l = 0; l < newTitty.length; l++) {
			if(isAlpha(startVal[0]) != -1) outString += String.fromCharCode(newTitty[l] + 97);
			else outString += String.fromCharCode(newTitty[l] + 48);
			}

		returnString[count++] = outString;
		}

	return returnString;
	}