/****************************** Start of GPL Block ****************************
 *   ImageHost Grabber - Imagegrabber is a firefox extension designed to 
 *   download pictures from image hosts such as imagevenue, imagebeaver, and 
 *   others (see help file for a full list of supported hosts).
 *
 *   Copyright (C) 2007   Matthew McMullen.
 * 
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 ***************************  End of GPL Block *******************************/




/* Define the menu items */

var MenuItem = new Array();

MenuItem[0] = cElem("menuitem");		// I believe there is a more intelligent way to do this
MenuItem[0].setAttribute("label", "Get all pics on page");
MenuItem[0].setAttribute("oncommand", "hostGrabber(true);");

MenuItem[1] = cElem("menuitem");
MenuItem[1].setAttribute("label", "Suck the current thread");
MenuItem[1].setAttribute("oncommand", "leechThread();");

MenuItem[2] = cElem("menuitem");
MenuItem[2].setAttribute("label", "Options");
MenuItem[2].setAttribute("oncommand", "openDialog('chrome://imagegrabber/content/options.xul', '', 'modal,toolbar');");



/* Define the menu popup element */

var MenuPopup = cElem("menupopup");

MenuPopup.appendChild(MenuItem[0]);
MenuPopup.appendChild(cElem("menuseparator"));
MenuPopup.appendChild(MenuItem[1]);
MenuPopup.appendChild(cElem("menuseparator"));
MenuPopup.appendChild(MenuItem[2]);



/* Define the menu element and set it's attributes */

var Menu = cElem("menu");

Menu.setAttribute("label", "Image Grabber");
Menu.setAttribute("accesskey", "I");
Menu.appendChild(MenuPopup);




/* Read the saved preferences and determine where to put the IG Menu */

var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var showInTools = prefManager.getBoolPref("extensions.imagegrabber.showintools");

if (showInTools) var menuPlacement = document.getElementById("tools-menu");
else var menuPlacement = document.getElementById("main-menubar");

menuPlacement.appendChild(Menu);



function cElem(name) {		// shortcut for create element, because I'm lazy
	//return document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", name);
	return document.createElement(name);
	}